c1a3202d410ef7cd62f5580e1b9d05743b9387bc
1#!/bin/sh
2#
3# git-submodule.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16OPTIONS_SPEC=
17. git-sh-setup
18. git-sh-i18n
19. git-parse-remote
20require_work_tree
21
22command=
23branch=
24force=
25reference=
26cached=
27recursive=
28init=
29files=
30nofetch=
31update=
32prefix=
33custom_name=
34
35# The function takes at most 2 arguments. The first argument is the
36# URL that navigates to the submodule origin repo. When relative, this URL
37# is relative to the superproject origin URL repo. The second up_path
38# argument, if specified, is the relative path that navigates
39# from the submodule working tree to the superproject working tree.
40#
41# The output of the function is the origin URL of the submodule.
42#
43# The output will either be an absolute URL or filesystem path (if the
44# superproject origin URL is an absolute URL or filesystem path,
45# respectively) or a relative file system path (if the superproject
46# origin URL is a relative file system path).
47#
48# When the output is a relative file system path, the path is either
49# relative to the submodule working tree, if up_path is specified, or to
50# the superproject working tree otherwise.
51resolve_relative_url ()
52{
53 remote=$(get_default_remote)
54 remoteurl=$(git config "remote.$remote.url") ||
55 remoteurl=$(pwd) # the repository is its own authoritative upstream
56 url="$1"
57 remoteurl=${remoteurl%/}
58 sep=/
59 up_path="$2"
60
61 case "$remoteurl" in
62 *:*|/*)
63 is_relative=
64 ;;
65 ./*|../*)
66 is_relative=t
67 ;;
68 *)
69 is_relative=t
70 remoteurl="./$remoteurl"
71 ;;
72 esac
73
74 while test -n "$url"
75 do
76 case "$url" in
77 ../*)
78 url="${url#../}"
79 case "$remoteurl" in
80 */*)
81 remoteurl="${remoteurl%/*}"
82 ;;
83 *:*)
84 remoteurl="${remoteurl%:*}"
85 sep=:
86 ;;
87 *)
88 if test -z "$is_relative" || test "." = "$remoteurl"
89 then
90 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
91 else
92 remoteurl=.
93 fi
94 ;;
95 esac
96 ;;
97 ./*)
98 url="${url#./}"
99 ;;
100 *)
101 break;;
102 esac
103 done
104 remoteurl="$remoteurl$sep${url%/}"
105 echo "${is_relative:+${up_path}}${remoteurl#./}"
106}
107
108#
109# Get submodule info for registered submodules
110# $@ = path to limit submodule list
111#
112module_list()
113{
114 (
115 git ls-files --error-unmatch --stage -- "$@" ||
116 echo "unmatched pathspec exists"
117 ) |
118 perl -e '
119 my %unmerged = ();
120 my ($null_sha1) = ("0" x 40);
121 my @out = ();
122 my $unmatched = 0;
123 while (<STDIN>) {
124 if (/^unmatched pathspec/) {
125 $unmatched = 1;
126 next;
127 }
128 chomp;
129 my ($mode, $sha1, $stage, $path) =
130 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
131 next unless $mode eq "160000";
132 if ($stage ne "0") {
133 if (!$unmerged{$path}++) {
134 push @out, "$mode $null_sha1 U\t$path\n";
135 }
136 next;
137 }
138 push @out, "$_\n";
139 }
140 if ($unmatched) {
141 print "#unmatched\n";
142 } else {
143 print for (@out);
144 }
145 '
146}
147
148die_if_unmatched ()
149{
150 if test "$1" = "#unmatched"
151 then
152 exit 1
153 fi
154}
155
156#
157# Map submodule path to submodule name
158#
159# $1 = path
160#
161module_name()
162{
163 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
164 sm_path="$1"
165 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
166 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
167 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
168 test -z "$name" &&
169 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
170 echo "$name"
171}
172
173#
174# Clone a submodule
175#
176# Prior to calling, cmd_update checks that a possibly existing
177# path is not a git repository.
178# Likewise, cmd_add checks that path does not exist at all,
179# since it is the location of a new submodule.
180#
181module_clone()
182{
183 sm_path=$1
184 name=$2
185 url=$3
186 reference="$4"
187 quiet=
188 if test -n "$GIT_QUIET"
189 then
190 quiet=-q
191 fi
192
193 gitdir=
194 gitdir_base=
195 base_name=$(dirname "$name")
196
197 gitdir=$(git rev-parse --git-dir)
198 gitdir_base="$gitdir/modules/$base_name"
199 gitdir="$gitdir/modules/$name"
200
201 if test -d "$gitdir"
202 then
203 mkdir -p "$sm_path"
204 rm -f "$gitdir/index"
205 else
206 mkdir -p "$gitdir_base"
207 (
208 clear_local_git_env
209 git clone $quiet -n ${reference:+"$reference"} \
210 --separate-git-dir "$gitdir" "$url" "$sm_path"
211 ) ||
212 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
213 fi
214
215 # We already are at the root of the work tree but cd_to_toplevel will
216 # resolve any symlinks that might be present in $PWD
217 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
218 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
219 # normalize Windows-style absolute paths to POSIX-style absolute paths
220 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
221 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
222 # Remove all common leading directories after a sanity check
223 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
224 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
225 fi
226 while test "${a%%/*}" = "${b%%/*}"
227 do
228 a=${a#*/}
229 b=${b#*/}
230 done
231 # Now chop off the trailing '/'s that were added in the beginning
232 a=${a%/}
233 b=${b%/}
234
235 # Turn each leading "*/" component into "../"
236 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
237 echo "gitdir: $rel/$a" >"$sm_path/.git"
238
239 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
240 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
241}
242
243#
244# Add a new submodule to the working tree, .gitmodules and the index
245#
246# $@ = repo path
247#
248# optional branch is stored in global branch variable
249#
250cmd_add()
251{
252 # parse $args after "submodule ... add".
253 while test $# -ne 0
254 do
255 case "$1" in
256 -b | --branch)
257 case "$2" in '') usage ;; esac
258 branch=$2
259 shift
260 ;;
261 -f | --force)
262 force=$1
263 ;;
264 -q|--quiet)
265 GIT_QUIET=1
266 ;;
267 --reference)
268 case "$2" in '') usage ;; esac
269 reference="--reference=$2"
270 shift
271 ;;
272 --reference=*)
273 reference="$1"
274 ;;
275 --name)
276 case "$2" in '') usage ;; esac
277 custom_name=$2
278 shift
279 ;;
280 --)
281 shift
282 break
283 ;;
284 -*)
285 usage
286 ;;
287 *)
288 break
289 ;;
290 esac
291 shift
292 done
293
294 repo=$1
295 sm_path=$2
296
297 if test -z "$sm_path"; then
298 sm_path=$(echo "$repo" |
299 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
300 fi
301
302 if test -z "$repo" -o -z "$sm_path"; then
303 usage
304 fi
305
306 # assure repo is absolute or relative to parent
307 case "$repo" in
308 ./*|../*)
309 # dereference source url relative to parent's url
310 realrepo=$(resolve_relative_url "$repo") || exit
311 ;;
312 *:*|/*)
313 # absolute url
314 realrepo=$repo
315 ;;
316 *)
317 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
318 ;;
319 esac
320
321 # normalize path:
322 # multiple //; leading ./; /./; /../; trailing /
323 sm_path=$(printf '%s/\n' "$sm_path" |
324 sed -e '
325 s|//*|/|g
326 s|^\(\./\)*||
327 s|/\./|/|g
328 :start
329 s|\([^/]*\)/\.\./||
330 tstart
331 s|/*$||
332 ')
333 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
334 die "$(eval_gettext "'\$sm_path' already exists in the index")"
335
336 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
337 then
338 eval_gettextln "The following path is ignored by one of your .gitignore files:
339\$sm_path
340Use -f if you really want to add it." >&2
341 exit 1
342 fi
343
344 if test -n "$custom_name"
345 then
346 sm_name="$custom_name"
347 else
348 sm_name="$sm_path"
349 fi
350
351 # perhaps the path exists and is already a git repo, else clone it
352 if test -e "$sm_path"
353 then
354 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
355 then
356 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
357 else
358 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
359 fi
360
361 else
362 if test -d ".git/modules/$sm_name"
363 then
364 if test -z "$force"
365 then
366 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
367 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
368 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
369 echo >&2 " $realrepo"
370 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
371 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
372 else
373 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
374 fi
375 fi
376 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" || exit
377 (
378 clear_local_git_env
379 cd "$sm_path" &&
380 # ash fails to wordsplit ${branch:+-b "$branch"...}
381 case "$branch" in
382 '') git checkout -f -q ;;
383 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
384 esac
385 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
386 fi
387 git config submodule."$sm_name".url "$realrepo"
388
389 git add $force "$sm_path" ||
390 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
391
392 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
393 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
394 git add --force .gitmodules ||
395 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
396}
397
398#
399# Execute an arbitrary command sequence in each checked out
400# submodule
401#
402# $@ = command to execute
403#
404cmd_foreach()
405{
406 # parse $args after "submodule ... foreach".
407 while test $# -ne 0
408 do
409 case "$1" in
410 -q|--quiet)
411 GIT_QUIET=1
412 ;;
413 --recursive)
414 recursive=1
415 ;;
416 -*)
417 usage
418 ;;
419 *)
420 break
421 ;;
422 esac
423 shift
424 done
425
426 toplevel=$(pwd)
427
428 # dup stdin so that it can be restored when running the external
429 # command in the subshell (and a recursive call to this function)
430 exec 3<&0
431
432 module_list |
433 while read mode sha1 stage sm_path
434 do
435 die_if_unmatched "$mode"
436 if test -e "$sm_path"/.git
437 then
438 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
439 name=$(module_name "$sm_path")
440 (
441 prefix="$prefix$sm_path/"
442 clear_local_git_env
443 # we make $path available to scripts ...
444 path=$sm_path
445 cd "$sm_path" &&
446 eval "$@" &&
447 if test -n "$recursive"
448 then
449 cmd_foreach "--recursive" "$@"
450 fi
451 ) <&3 3<&- ||
452 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
453 fi
454 done
455}
456
457#
458# Register submodules in .git/config
459#
460# $@ = requested paths (default to all)
461#
462cmd_init()
463{
464 # parse $args after "submodule ... init".
465 while test $# -ne 0
466 do
467 case "$1" in
468 -q|--quiet)
469 GIT_QUIET=1
470 ;;
471 --)
472 shift
473 break
474 ;;
475 -*)
476 usage
477 ;;
478 *)
479 break
480 ;;
481 esac
482 shift
483 done
484
485 module_list "$@" |
486 while read mode sha1 stage sm_path
487 do
488 die_if_unmatched "$mode"
489 name=$(module_name "$sm_path") || exit
490
491 # Copy url setting when it is not set yet
492 if test -z "$(git config "submodule.$name.url")"
493 then
494 url=$(git config -f .gitmodules submodule."$name".url)
495 test -z "$url" &&
496 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
497
498 # Possibly a url relative to parent
499 case "$url" in
500 ./*|../*)
501 url=$(resolve_relative_url "$url") || exit
502 ;;
503 esac
504 git config submodule."$name".url "$url" ||
505 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
506
507 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
508 fi
509
510 # Copy "update" setting when it is not set yet
511 upd="$(git config -f .gitmodules submodule."$name".update)"
512 test -z "$upd" ||
513 test -n "$(git config submodule."$name".update)" ||
514 git config submodule."$name".update "$upd" ||
515 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
516 done
517}
518
519#
520# Unregister submodules from .git/config and remove their work tree
521#
522# $@ = requested paths (use '.' to deinit all submodules)
523#
524cmd_deinit()
525{
526 # parse $args after "submodule ... deinit".
527 while test $# -ne 0
528 do
529 case "$1" in
530 -f|--force)
531 force=$1
532 ;;
533 -q|--quiet)
534 GIT_QUIET=1
535 ;;
536 --)
537 shift
538 break
539 ;;
540 -*)
541 usage
542 ;;
543 *)
544 break
545 ;;
546 esac
547 shift
548 done
549
550 if test $# = 0
551 then
552 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
553 fi
554
555 module_list "$@" |
556 while read mode sha1 stage sm_path
557 do
558 die_if_unmatched "$mode"
559 name=$(module_name "$sm_path") || exit
560
561 # Remove the submodule work tree (unless the user already did it)
562 if test -d "$sm_path"
563 then
564 # Protect submodules containing a .git directory
565 if test -d "$sm_path/.git"
566 then
567 echo >&2 "$(eval_gettext "Submodule work tree '\$sm_path' contains a .git directory")"
568 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
569 fi
570
571 if test -z "$force"
572 then
573 git rm -n "$sm_path" ||
574 die "$(eval_gettext "Submodule work tree '\$sm_path' contains local modifications; use '-f' to discard them")"
575 fi
576 rm -rf "$sm_path" || say "$(eval_gettext "Could not remove submodule work tree '\$sm_path'")"
577 fi
578
579 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$sm_path'")"
580
581 # Remove the .git/config entries (unless the user already did it)
582 if test -n "$(git config --get-regexp submodule."$name\.")"
583 then
584 # Remove the whole section so we have a clean state when
585 # the user later decides to init this submodule again
586 url=$(git config submodule."$name".url)
587 git config --remove-section submodule."$name" 2>/dev/null &&
588 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$sm_path'")"
589 fi
590 done
591}
592
593#
594# Update each submodule path to correct revision, using clone and checkout as needed
595#
596# $@ = requested paths (default to all)
597#
598cmd_update()
599{
600 # parse $args after "submodule ... update".
601 orig_flags=
602 while test $# -ne 0
603 do
604 case "$1" in
605 -q|--quiet)
606 GIT_QUIET=1
607 ;;
608 -i|--init)
609 init=1
610 ;;
611 -N|--no-fetch)
612 nofetch=1
613 ;;
614 -f|--force)
615 force=$1
616 ;;
617 -r|--rebase)
618 update="rebase"
619 ;;
620 --reference)
621 case "$2" in '') usage ;; esac
622 reference="--reference=$2"
623 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
624 shift
625 ;;
626 --reference=*)
627 reference="$1"
628 ;;
629 -m|--merge)
630 update="merge"
631 ;;
632 --recursive)
633 recursive=1
634 ;;
635 --checkout)
636 update="checkout"
637 ;;
638 --)
639 shift
640 break
641 ;;
642 -*)
643 usage
644 ;;
645 *)
646 break
647 ;;
648 esac
649 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
650 shift
651 done
652
653 if test -n "$init"
654 then
655 cmd_init "--" "$@" || return
656 fi
657
658 cloned_modules=
659 module_list "$@" | {
660 err=
661 while read mode sha1 stage sm_path
662 do
663 die_if_unmatched "$mode"
664 if test "$stage" = U
665 then
666 echo >&2 "Skipping unmerged submodule $sm_path"
667 continue
668 fi
669 name=$(module_name "$sm_path") || exit
670 url=$(git config submodule."$name".url)
671 if ! test -z "$update"
672 then
673 update_module=$update
674 else
675 update_module=$(git config submodule."$name".update)
676 fi
677
678 if test "$update_module" = "none"
679 then
680 echo "Skipping submodule '$sm_path'"
681 continue
682 fi
683
684 if test -z "$url"
685 then
686 # Only mention uninitialized submodules when its
687 # path have been specified
688 test "$#" != "0" &&
689 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
690Maybe you want to use 'update --init'?")"
691 continue
692 fi
693
694 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
695 then
696 module_clone "$sm_path" "$name" "$url" "$reference" || exit
697 cloned_modules="$cloned_modules;$name"
698 subsha1=
699 else
700 subsha1=$(clear_local_git_env; cd "$sm_path" &&
701 git rev-parse --verify HEAD) ||
702 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
703 fi
704
705 if test "$subsha1" != "$sha1" -o -n "$force"
706 then
707 subforce=$force
708 # If we don't already have a -f flag and the submodule has never been checked out
709 if test -z "$subsha1" -a -z "$force"
710 then
711 subforce="-f"
712 fi
713
714 if test -z "$nofetch"
715 then
716 # Run fetch only if $sha1 isn't present or it
717 # is not reachable from a ref.
718 (clear_local_git_env; cd "$sm_path" &&
719 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
720 test -z "$rev") || git-fetch)) ||
721 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
722 fi
723
724 # Is this something we just cloned?
725 case ";$cloned_modules;" in
726 *";$name;"*)
727 # then there is no local change to integrate
728 update_module= ;;
729 esac
730
731 must_die_on_failure=
732 case "$update_module" in
733 rebase)
734 command="git rebase"
735 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
736 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
737 must_die_on_failure=yes
738 ;;
739 merge)
740 command="git merge"
741 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
742 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
743 must_die_on_failure=yes
744 ;;
745 *)
746 command="git checkout $subforce -q"
747 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
748 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
749 ;;
750 esac
751
752 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
753 then
754 say "$say_msg"
755 elif test -n "$must_die_on_failure"
756 then
757 die_with_status 2 "$die_msg"
758 else
759 err="${err};$die_msg"
760 continue
761 fi
762 fi
763
764 if test -n "$recursive"
765 then
766 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
767 res=$?
768 if test $res -gt 0
769 then
770 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
771 if test $res -eq 1
772 then
773 err="${err};$die_msg"
774 continue
775 else
776 die_with_status $res "$die_msg"
777 fi
778 fi
779 fi
780 done
781
782 if test -n "$err"
783 then
784 OIFS=$IFS
785 IFS=';'
786 for e in $err
787 do
788 if test -n "$e"
789 then
790 echo >&2 "$e"
791 fi
792 done
793 IFS=$OIFS
794 exit 1
795 fi
796 }
797}
798
799set_name_rev () {
800 revname=$( (
801 clear_local_git_env
802 cd "$1" && {
803 git describe "$2" 2>/dev/null ||
804 git describe --tags "$2" 2>/dev/null ||
805 git describe --contains "$2" 2>/dev/null ||
806 git describe --all --always "$2"
807 }
808 ) )
809 test -z "$revname" || revname=" ($revname)"
810}
811#
812# Show commit summary for submodules in index or working tree
813#
814# If '--cached' is given, show summary between index and given commit,
815# or between working tree and given commit
816#
817# $@ = [commit (default 'HEAD'),] requested paths (default all)
818#
819cmd_summary() {
820 summary_limit=-1
821 for_status=
822 diff_cmd=diff-index
823
824 # parse $args after "submodule ... summary".
825 while test $# -ne 0
826 do
827 case "$1" in
828 --cached)
829 cached="$1"
830 ;;
831 --files)
832 files="$1"
833 ;;
834 --for-status)
835 for_status="$1"
836 ;;
837 -n|--summary-limit)
838 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
839 then
840 :
841 else
842 usage
843 fi
844 shift
845 ;;
846 --)
847 shift
848 break
849 ;;
850 -*)
851 usage
852 ;;
853 *)
854 break
855 ;;
856 esac
857 shift
858 done
859
860 test $summary_limit = 0 && return
861
862 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
863 then
864 head=$rev
865 test $# = 0 || shift
866 elif test -z "$1" -o "$1" = "HEAD"
867 then
868 # before the first commit: compare with an empty tree
869 head=$(git hash-object -w -t tree --stdin </dev/null)
870 test -z "$1" || shift
871 else
872 head="HEAD"
873 fi
874
875 if [ -n "$files" ]
876 then
877 test -n "$cached" &&
878 die "$(gettext "The --cached option cannot be used with the --files option")"
879 diff_cmd=diff-files
880 head=
881 fi
882
883 cd_to_toplevel
884 # Get modified modules cared by user
885 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
886 sane_egrep '^:([0-7]* )?160000' |
887 while read mod_src mod_dst sha1_src sha1_dst status name
888 do
889 # Always show modules deleted or type-changed (blob<->module)
890 test $status = D -o $status = T && echo "$name" && continue
891 # Also show added or modified modules which are checked out
892 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
893 echo "$name"
894 done
895 )
896
897 test -z "$modules" && return
898
899 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
900 sane_egrep '^:([0-7]* )?160000' |
901 cut -c2- |
902 while read mod_src mod_dst sha1_src sha1_dst status name
903 do
904 if test -z "$cached" &&
905 test $sha1_dst = 0000000000000000000000000000000000000000
906 then
907 case "$mod_dst" in
908 160000)
909 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
910 ;;
911 100644 | 100755 | 120000)
912 sha1_dst=$(git hash-object $name)
913 ;;
914 000000)
915 ;; # removed
916 *)
917 # unexpected type
918 eval_gettextln "unexpected mode \$mod_dst" >&2
919 continue ;;
920 esac
921 fi
922 missing_src=
923 missing_dst=
924
925 test $mod_src = 160000 &&
926 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
927 missing_src=t
928
929 test $mod_dst = 160000 &&
930 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
931 missing_dst=t
932
933 total_commits=
934 case "$missing_src,$missing_dst" in
935 t,)
936 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
937 ;;
938 ,t)
939 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
940 ;;
941 t,t)
942 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
943 ;;
944 *)
945 errmsg=
946 total_commits=$(
947 if test $mod_src = 160000 -a $mod_dst = 160000
948 then
949 range="$sha1_src...$sha1_dst"
950 elif test $mod_src = 160000
951 then
952 range=$sha1_src
953 else
954 range=$sha1_dst
955 fi
956 GIT_DIR="$name/.git" \
957 git rev-list --first-parent $range -- | wc -l
958 )
959 total_commits=" ($(($total_commits + 0)))"
960 ;;
961 esac
962
963 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
964 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
965 if test $status = T
966 then
967 blob="$(gettext "blob")"
968 submodule="$(gettext "submodule")"
969 if test $mod_dst = 160000
970 then
971 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
972 else
973 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
974 fi
975 else
976 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
977 fi
978 if test -n "$errmsg"
979 then
980 # Don't give error msg for modification whose dst is not submodule
981 # i.e. deleted or changed to blob
982 test $mod_dst = 160000 && echo "$errmsg"
983 else
984 if test $mod_src = 160000 -a $mod_dst = 160000
985 then
986 limit=
987 test $summary_limit -gt 0 && limit="-$summary_limit"
988 GIT_DIR="$name/.git" \
989 git log $limit --pretty='format: %m %s' \
990 --first-parent $sha1_src...$sha1_dst
991 elif test $mod_dst = 160000
992 then
993 GIT_DIR="$name/.git" \
994 git log --pretty='format: > %s' -1 $sha1_dst
995 else
996 GIT_DIR="$name/.git" \
997 git log --pretty='format: < %s' -1 $sha1_src
998 fi
999 echo
1000 fi
1001 echo
1002 done |
1003 if test -n "$for_status"; then
1004 if [ -n "$files" ]; then
1005 gettextln "# Submodules changed but not updated:"
1006 else
1007 gettextln "# Submodule changes to be committed:"
1008 fi
1009 echo "#"
1010 sed -e 's|^|# |' -e 's|^# $|#|'
1011 else
1012 cat
1013 fi
1014}
1015#
1016# List all submodules, prefixed with:
1017# - submodule not initialized
1018# + different revision checked out
1019#
1020# If --cached was specified the revision in the index will be printed
1021# instead of the currently checked out revision.
1022#
1023# $@ = requested paths (default to all)
1024#
1025cmd_status()
1026{
1027 # parse $args after "submodule ... status".
1028 while test $# -ne 0
1029 do
1030 case "$1" in
1031 -q|--quiet)
1032 GIT_QUIET=1
1033 ;;
1034 --cached)
1035 cached=1
1036 ;;
1037 --recursive)
1038 recursive=1
1039 ;;
1040 --)
1041 shift
1042 break
1043 ;;
1044 -*)
1045 usage
1046 ;;
1047 *)
1048 break
1049 ;;
1050 esac
1051 shift
1052 done
1053
1054 module_list "$@" |
1055 while read mode sha1 stage sm_path
1056 do
1057 die_if_unmatched "$mode"
1058 name=$(module_name "$sm_path") || exit
1059 url=$(git config submodule."$name".url)
1060 displaypath="$prefix$sm_path"
1061 if test "$stage" = U
1062 then
1063 say "U$sha1 $displaypath"
1064 continue
1065 fi
1066 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1067 then
1068 say "-$sha1 $displaypath"
1069 continue;
1070 fi
1071 set_name_rev "$sm_path" "$sha1"
1072 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1073 then
1074 say " $sha1 $displaypath$revname"
1075 else
1076 if test -z "$cached"
1077 then
1078 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1079 set_name_rev "$sm_path" "$sha1"
1080 fi
1081 say "+$sha1 $displaypath$revname"
1082 fi
1083
1084 if test -n "$recursive"
1085 then
1086 (
1087 prefix="$displaypath/"
1088 clear_local_git_env
1089 cd "$sm_path" &&
1090 eval cmd_status
1091 ) ||
1092 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1093 fi
1094 done
1095}
1096#
1097# Sync remote urls for submodules
1098# This makes the value for remote.$remote.url match the value
1099# specified in .gitmodules.
1100#
1101cmd_sync()
1102{
1103 while test $# -ne 0
1104 do
1105 case "$1" in
1106 -q|--quiet)
1107 GIT_QUIET=1
1108 shift
1109 ;;
1110 --recursive)
1111 recursive=1
1112 shift
1113 ;;
1114 --)
1115 shift
1116 break
1117 ;;
1118 -*)
1119 usage
1120 ;;
1121 *)
1122 break
1123 ;;
1124 esac
1125 done
1126 cd_to_toplevel
1127 module_list "$@" |
1128 while read mode sha1 stage sm_path
1129 do
1130 die_if_unmatched "$mode"
1131 name=$(module_name "$sm_path")
1132 url=$(git config -f .gitmodules --get submodule."$name".url)
1133
1134 # Possibly a url relative to parent
1135 case "$url" in
1136 ./*|../*)
1137 # rewrite foo/bar as ../.. to find path from
1138 # submodule work tree to superproject work tree
1139 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1140 # guarantee a trailing /
1141 up_path=${up_path%/}/ &&
1142 # path from submodule work tree to submodule origin repo
1143 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1144 # path from superproject work tree to submodule origin repo
1145 super_config_url=$(resolve_relative_url "$url") || exit
1146 ;;
1147 *)
1148 sub_origin_url="$url"
1149 super_config_url="$url"
1150 ;;
1151 esac
1152
1153 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1154 then
1155 say "$(eval_gettext "Synchronizing submodule url for '\$prefix\$sm_path'")"
1156 git config submodule."$name".url "$super_config_url"
1157
1158 if test -e "$sm_path"/.git
1159 then
1160 (
1161 clear_local_git_env
1162 cd "$sm_path"
1163 remote=$(get_default_remote)
1164 git config remote."$remote".url "$sub_origin_url"
1165
1166 if test -n "$recursive"
1167 then
1168 prefix="$prefix$sm_path/"
1169 eval cmd_sync
1170 fi
1171 )
1172 fi
1173 fi
1174 done
1175}
1176
1177# This loop parses the command line arguments to find the
1178# subcommand name to dispatch. Parsing of the subcommand specific
1179# options are primarily done by the subcommand implementations.
1180# Subcommand specific options such as --branch and --cached are
1181# parsed here as well, for backward compatibility.
1182
1183while test $# != 0 && test -z "$command"
1184do
1185 case "$1" in
1186 add | foreach | init | deinit | update | status | summary | sync)
1187 command=$1
1188 ;;
1189 -q|--quiet)
1190 GIT_QUIET=1
1191 ;;
1192 -b|--branch)
1193 case "$2" in
1194 '')
1195 usage
1196 ;;
1197 esac
1198 branch="$2"; shift
1199 ;;
1200 --cached)
1201 cached="$1"
1202 ;;
1203 --)
1204 break
1205 ;;
1206 -*)
1207 usage
1208 ;;
1209 *)
1210 break
1211 ;;
1212 esac
1213 shift
1214done
1215
1216# No command word defaults to "status"
1217if test -z "$command"
1218then
1219 if test $# = 0
1220 then
1221 command=status
1222 else
1223 usage
1224 fi
1225fi
1226
1227# "-b branch" is accepted only by "add"
1228if test -n "$branch" && test "$command" != add
1229then
1230 usage
1231fi
1232
1233# "--cached" is accepted only by "status" and "summary"
1234if test -n "$cached" && test "$command" != status -a "$command" != summary
1235then
1236 usage
1237fi
1238
1239"cmd_$command" "$@"